diff --git a/tools/perf/util/bpf-loader.c b/tools/perf/util/bpf-loader.c
index bf61a6f..9a0c33d 100644
--- a/tools/perf/util/bpf-loader.c
+++ b/tools/perf/util/bpf-loader.c
@@ -47,6 +47,10 @@ struct bpf_prog_priv {
 	int *type_mapping;
 };
 
+struct bpf_obj_priv {
+	void *map_base;
+};
+
 static bool libbpf_initialized;
 
 struct bpf_object *
@@ -70,9 +74,20 @@ bpf__prepare_load_buffer(void *obj_buf, size_t obj_buf_sz, const char *name)
 	return obj;
 }
 
+static void
+clear_obj_priv(struct bpf_object *obj __maybe_unused,
+	       void *_priv)
+{
+	struct bpf_obj_priv *priv = _priv;
+
+	free(priv);
+}
+
 struct bpf_object *bpf__prepare_load(const char *filename, bool source)
 {
 	struct bpf_object *obj;
+	void *map_base = NULL;
+	int err;
 
 	if (!libbpf_initialized) {
 		libbpf_set_print(libbpf_warning,
@@ -82,14 +97,14 @@ struct bpf_object *bpf__prepare_load(const char *filename, bool source)
 	}
 
 	if (source) {
-		int err;
 		void *obj_buf;
 		size_t obj_buf_sz;
 		jitted_funcs_map_t jitted_funcs_map;
 
 		perf_clang__init();
 		err = perf_clang__compile_bpf(filename, &obj_buf,
-					      &obj_buf_sz, &jitted_funcs_map);
+					      &obj_buf_sz, &jitted_funcs_map,
+					      &map_base);
 		perf_clang__cleanup();
 		if (err) {
 			pr_warning("bpf: builtin compilation failed: %d, try external compiler\n", err);
@@ -119,7 +134,27 @@ struct bpf_object *bpf__prepare_load(const char *filename, bool source)
 		return obj;
 	}
 
+	if (map_base) {
+		struct bpf_obj_priv *priv = calloc(sizeof(*priv), 1);
+
+		if (!priv) {
+			pr_debug("bpf: failed to alloc priv for object\n");
+			err = -ENOMEM;
+			goto errout;
+		}
+		priv->map_base = map_base;
+
+		err = bpf_object__set_priv(obj, priv, clear_obj_priv);
+		if (err) {
+			pr_debug("Failed to set priv for object '%s'\n", filename);
+			goto errout;
+		}
+	}
+
 	return obj;
+errout:
+	bpf_object__close(obj);
+	return ERR_PTR(err);
 }
 
 void bpf__clear(void)
diff --git a/tools/perf/util/c++/clang-c.h b/tools/perf/util/c++/clang-c.h
index 021b1ad..4cf651b 100644
--- a/tools/perf/util/c++/clang-c.h
+++ b/tools/perf/util/c++/clang-c.h
@@ -22,7 +22,8 @@ extern void test__clang_callback(int x);
 extern int perf_clang__compile_bpf(const char *filename,
 				   void **p_obj_buf,
 				   size_t *p_obj_buf_sz,
-				   jitted_funcs_map_t *p_funcs_map);
+				   jitted_funcs_map_t *p_funcs_map,
+				   void **p_map_base);
 
 extern int
 perf_clang__hook_jitted_func(jitted_funcs_map_t map, void *ctx, bool is_err);
@@ -40,7 +41,8 @@ static inline int
 perf_clang__compile_bpf(const char *filename __maybe_unused,
 			void **p_obj_buf __maybe_unused,
 			size_t *p_obj_buf_sz __maybe_unused,
-			jitted_funcs_map_t *p_funcs_map __maybe_unused)
+			jitted_funcs_map_t *p_funcs_map __maybe_unused,
+			void **p_map_base __maybe_unused)
 {
 	return -ENOTSUP;
 }
diff --git a/tools/perf/util/c++/clang.cpp b/tools/perf/util/c++/clang.cpp
index 4a98597..684855c 100644
--- a/tools/perf/util/c++/clang.cpp
+++ b/tools/perf/util/c++/clang.cpp
@@ -119,7 +119,7 @@ getModuleFromSource(llvm::opt::ArgStringList CFlags, StringRef Path)
 	return getModuleFromSource(std::move(CFlags), Path, VFS);
 }
 
-PerfModule::PerfModule(std::unique_ptr<llvm::Module>&& M) : Module(std::move(M))
+PerfModule::PerfModule(std::unique_ptr<llvm::Module>&& M) : Module(std::move(M)), _map_base(NULL)
 {
 	for (llvm::Function& F : *Module) {
 		if (F.getLinkage() != llvm::GlobalValue::ExternalLinkage)
@@ -250,6 +250,13 @@ int PerfModule::doJIT(void)
 			&JITMemoryManager,
 			std::move(Resolver));
 
+	void *map_base = NULL;
+	for (llvm::GlobalValue *map : Maps) {
+		JITSymbol sym = CompileLayer.findSymbol(map->getName().str(), true);
+		void *address = (void *)(intptr_t)sym.getAddress();
+		if (!map_base || address < map_base)
+			map_base = address;
+	}
 
 	for (Function *F : JITFunctions) {
 		JITSymbol sym = CompileLayer.findSymbol(F->getName().str(), true);
@@ -269,6 +276,7 @@ int PerfModule::doJIT(void)
 				     << hook << ", only one is used\n";
 		JITResult[hook] = func;
 	}
+	_map_base = map_base;
 	return 0;
 }
 
@@ -392,7 +400,8 @@ void perf_clang__cleanup(void)
 int perf_clang__compile_bpf(const char *_filename,
 			    void **p_obj_buf,
 			    size_t *p_obj_buf_sz,
-			    jitted_funcs_map_t *p_funcs_map)
+			    jitted_funcs_map_t *p_funcs_map,
+			    void **p_map_base)
 {
 	using namespace perf;
 
@@ -425,6 +434,8 @@ int perf_clang__compile_bpf(const char *_filename,
 
 	if (p_funcs_map)
 		*p_funcs_map = (jitted_funcs_map_t)(M->copyJITResult());
+	if (p_map_base)
+		*p_map_base = M->getMapBase();
 	return 0;
 }
 
diff --git a/tools/perf/util/c++/clang.h b/tools/perf/util/c++/clang.h
index df2eb8f..aacedc2 100644
--- a/tools/perf/util/c++/clang.h
+++ b/tools/perf/util/c++/clang.h
@@ -26,6 +26,7 @@ class PerfModule {
 	std::set<llvm::Function *> JITFunctions;
 
 	HookMap JITResult;
+	void *_map_base;
 
 	void prepareBPF(void);
 	void prepareJIT(void);
@@ -38,6 +39,10 @@ class PerfModule {
 	{
 		return new HookMap(JITResult);
 	}
+	inline void *getMapBase(void)
+	{
+		return _map_base;
+	}
 
 	PerfModule(std::unique_ptr<llvm::Module>&& M);
 